/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package eu.agrosense.client.calendar.api.internal.gui;

import javafx.scene.control.Label;
import javafx.scene.layout.Region;

public class RegionWithTitle extends Region {

	private static final int LEFT_INDENT = 10;
	private static final String SHORT_TEXT = "...";
	String title;
	Label label;
	double barXPosition = 0;
	double barWidth = 0;

	public RegionWithTitle(String title) {
		this.title = title;
		label = new Label(title);
		label.getStyleClass().add("calendar-bar-title");
		getChildren().add(label);
	}

	@Override
	protected void layoutChildren() {
		super.layoutChildren();
		double visibleWidth = getVisibleWidth();
		label.setText(title);
		if (visibleWidth > label.getWidth() + LEFT_INDENT) {
			double x = 0;
			if (barXPosition < 0) {
				x = -barXPosition;
			}
			label.setLayoutX(x + LEFT_INDENT);
		} else {
			label.setText(SHORT_TEXT);
			label.setLayoutX(0);
		}
	}

	private double getVisibleWidth() {
		if (barXPosition < 0) {
			return barXPosition + barWidth;
		} else {
			return barWidth;
		}
	}

	void updateTitleLayout(double barXPosition, double barWidth) {
		this.barWidth = barWidth;
		this.barXPosition = barXPosition;
		// need to call layoutChildren manually, because sometimes its not called. why?
		layoutChildren();
	}
	
}
